package com.gic.haoban.manage.service.service.out.impl.hm;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.BasePageInfo;
import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.manage.api.dto.hm.HmLinkDTO;
import com.gic.haoban.manage.api.dto.hm.HmLinkStoreDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmLinkSearchQDTO;
import com.gic.haoban.manage.api.service.hm.HmLinkApiService;
import com.gic.haoban.manage.service.entity.hm.TabHmLink;
import com.gic.haoban.manage.service.service.hm.HmLinkService;
import com.gic.haoban.manage.service.service.hm.HmLinkStoreService;

@Service("hmLinkApiService")
public class HmLinkApiServiceImpl implements HmLinkApiService {

    @Autowired
    private HmLinkService hmLinkService;
    @Autowired
    private HmLinkStoreService hmLinkStoreService;

    @Override
    public HmLinkDTO getByLinkId(String wxEnterpriseId, String enterpriseId, Long linkId) {
        TabHmLink link = this.hmLinkService.getByLinkId(wxEnterpriseId, enterpriseId, linkId);
        if (null != link) {
            HmLinkDTO dto = EntityUtil.changeEntityByJSON(HmLinkDTO.class, link);
            List<HmLinkStoreDTO> storeList = this.hmLinkStoreService.listByLinkId(dto.getWxEnterpriseId(),
                    dto.getEnterpriseId(), linkId);
            dto.setStoreList(storeList);
            return dto;
        }
        return null;
    }

    @Override
    public List<HmLinkDTO> listForSms(String wxEnterpriseId, String enterprieId, String linkName) {
        return this.hmLinkService.listForSms(wxEnterpriseId, enterprieId, linkName);
    }

    @Override
    public HmLinkDTO save(HmLinkDTO dto) {
        return this.hmLinkService.saveLink(dto, dto.getStoreList());
    }

    @Override
    public Page<HmLinkDTO> listPage(HmLinkSearchQDTO qdto, BasePageInfo basePageInfo) {
        return this.hmLinkService.listPage(qdto, basePageInfo);
    }

}
